Package com.ngrok.definitions

# Class ReservedDomain

java.lang.Object
com.ngrok.definitions.ReservedDomain

public class ReservedDomain extends Object
A class encapsulating the `ReservedDomain` resource.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ReservedDomain(String id, URI uri, OffsetDateTime createdAt, String description, String metadata, String domain, String region, Optional<String> cnameTarget, Optional<Ref> certificate, Optional<ReservedDomainCertPolicy> certificateManagementPolicy, Optional<ReservedDomainCertStatus> certificateManagementStatus, Optional<String> acmeChallengeCnameTarget)`
  Creates a new instance of `ReservedDomain`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  `Optional<String>`
  `getAcmeChallengeCnameTarget()`
  DNS CNAME target for the host _acme-challenge.example.com, where example.com is your reserved domain name.
  `Optional<Ref>`
  `getCertificate()`
  object referencing the TLS certificate used for connections to this domain.
  `Optional<ReservedDomainCertPolicy>`
  `getCertificateManagementPolicy()`
  configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled
  `Optional<ReservedDomainCertStatus>`
  `getCertificateManagementStatus()`
  status of the automatic certificate management for this domain, or null if automatic management is disabled
  `Optional<String>`
  `getCnameTarget()`
  DNS CNAME target for a custom hostname, or null if the reserved domain is a subdomain of *.ngrok.io
  `OffsetDateTime`
  `getCreatedAt()`
  timestamp when the reserved domain was created, RFC 3339 format
  `String`
  `getDescription()`
  human-readable description of what this reserved domain will be used for
  `String`
  `getDomain()`
  hostname of the reserved domain
  `String`
  `getId()`
  unique reserved domain resource identifier
  `String`
  `getMetadata()`
  arbitrary user-defined machine-readable data of this reserved domain.
  `String`
  `getRegion()`
  reserve the domain in this geographic ngrok datacenter.
  `URI`
  `getUri()`
  URI of the reserved domain API resource
  `int`
  `hashCode()`
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ReservedDomain

    public ReservedDomain(String id, URI uri, OffsetDateTime createdAt, String description, String metadata, String domain, String region, Optional<String> cnameTarget, Optional<Ref> certificate, Optional<ReservedDomainCertPolicy> certificateManagementPolicy, Optional<ReservedDomainCertStatus> certificateManagementStatus, Optional<String> acmeChallengeCnameTarget)
    Creates a new instance of `ReservedDomain`.
    Parameters:
      `id` - unique reserved domain resource identifier
      `uri` - URI of the reserved domain API resource
      `createdAt` - timestamp when the reserved domain was created, RFC 3339 format
      `description` - human-readable description of what this reserved domain will be used for
      `metadata` - arbitrary user-defined machine-readable data of this reserved domain. Optional, max 4096 bytes.
      `domain` - hostname of the reserved domain
      `region` - reserve the domain in this geographic ngrok datacenter. Optional, default is us. (au, eu, ap, us, jp, in, sa)
      `cnameTarget` - DNS CNAME target for a custom hostname, or null if the reserved domain is a subdomain of *.ngrok.io
      `certificate` - object referencing the TLS certificate used for connections to this domain. This can be either a user-uploaded certificate, the most recently issued automatic one, or null otherwise.
      `certificateManagementPolicy` - configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled
      `certificateManagementStatus` - status of the automatic certificate management for this domain, or null if automatic management is disabled
      `acmeChallengeCnameTarget` - DNS CNAME target for the host _acme-challenge.example.com, where example.com is your reserved domain name. This is required to issue certificates for wildcard, non-ngrok reserved domains. Must be null for non-wildcard domains and ngrok subdomains.

- ## Method Details

  - ### getId

    public String getId()
    unique reserved domain resource identifier
    Returns:
      the value of the property as a `String`

  - ### getUri

    public URI getUri()
    URI of the reserved domain API resource
    Returns:
      the value of the property as a `URI`

  - ### getCreatedAt

    public OffsetDateTime getCreatedAt()
    timestamp when the reserved domain was created, RFC 3339 format
    Returns:
      the value of the property as a `OffsetDateTime`

  - ### getDescription

    public String getDescription()
    human-readable description of what this reserved domain will be used for
    Returns:
      the value of the property as a `String`

  - ### getMetadata

    public String getMetadata()
    arbitrary user-defined machine-readable data of this reserved domain. Optional, max 4096 bytes.
    Returns:
      the value of the property as a `String`

  - ### getDomain

    public String getDomain()
    hostname of the reserved domain
    Returns:
      the value of the property as a `String`

  - ### getRegion

    public String getRegion()
    reserve the domain in this geographic ngrok datacenter. Optional, default is us. (au, eu, ap, us, jp, in, sa)
    Returns:
      the value of the property as a `String`

  - ### getCnameTarget

    public Optional<String> getCnameTarget()
    DNS CNAME target for a custom hostname, or null if the reserved domain is a subdomain of *.ngrok.io
    Returns:
      the value of the property as a `String` wrapped in an `Optional`

  - ### getCertificate

    public Optional<Ref> getCertificate()
    object referencing the TLS certificate used for connections to this domain. This can be either a user-uploaded certificate, the most recently issued automatic one, or null otherwise.
    Returns:
      the value of the property as a `Ref` wrapped in an `Optional`

  - ### getCertificateManagementPolicy

    public Optional<ReservedDomainCertPolicy> getCertificateManagementPolicy()
    configuration for automatic management of TLS certificates for this domain, or null if automatic management is disabled
    Returns:
      the value of the property as a `ReservedDomainCertPolicy` wrapped in an `Optional`

  - ### getCertificateManagementStatus

    public Optional<ReservedDomainCertStatus> getCertificateManagementStatus()
    status of the automatic certificate management for this domain, or null if automatic management is disabled
    Returns:
      the value of the property as a `ReservedDomainCertStatus` wrapped in an `Optional`

  - ### getAcmeChallengeCnameTarget

    public Optional<String> getAcmeChallengeCnameTarget()
    DNS CNAME target for the host _acme-challenge.example.com, where example.com is your reserved domain name. This is required to issue certificates for wildcard, non-ngrok reserved domains. Must be null for non-wildcard domains and ngrok subdomains.
    Returns:
      the value of the property as a `String` wrapped in an `Optional`

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`